package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.service.DepartmentService;

@Service
public class DepartmentApiServiceImpl implements DepartmentApiService {
	
	@Autowired
	private DepartmentService departmentService;

	@Override
	public List<DepartmentDTO> listByParentId(String parentId) {
		List<TabHaobanDepartment> list = departmentService.listByParentId(parentId);
		
		return EntityUtil.changeEntityListByJSON(DepartmentDTO.class, list);
	}

	@Override
	public DepartmentDTO selectById(String departmentId) {
		TabHaobanDepartment tab = departmentService.selectById(departmentId);
		return EntityUtil.changeEntityByJSON(DepartmentDTO.class, tab);
	}

	@Override
	public HaobanResponse add(DepartmentDTO department) {
		HaobanResponse hr = new HaobanResponse();
		hr.setErrorCode(1);
		//调微信的新增接口
		String wxDepartmentId = "";
		if(StringUtils.isBlank(wxDepartmentId)) {
			hr.setErrorCode(0);
			hr.setMessage("微信新增部门失败");
			return hr;
		}
		department.setWxDepartmentId(wxDepartmentId);
		departmentService.add(department);
		return hr;
	}

	@Override
	public HaobanResponse edit(DepartmentDTO department) {
		HaobanResponse hr = new HaobanResponse();
		hr.setErrorCode(1);
		//调微信的修改接口
		String wxDepartmentId = "";
		if(StringUtils.isBlank(wxDepartmentId)) {
			hr.setErrorCode(0);
			hr.setMessage("微信修改部门失败");
			return hr;
		}
		
		departmentService.edit(department);
		return hr;
	}

	@Override
	public HaobanResponse del(String departmentId) {
		HaobanResponse hr = new HaobanResponse();
		hr.setErrorCode(1);
		//调微信的新增接口
		String wxDepartmentId = "";
		if(StringUtils.isBlank(wxDepartmentId)) {
			hr.setErrorCode(0);
			hr.setMessage("微信删除部门失败");
			return hr;
		}
		departmentService.del(departmentId);
		return hr;
	}

}
