package com.gic.haoban.manage.service.service.out.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.service.dao.mapper.DepartmentMapper;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.service.DepartmentService;

@Service
public class DepartmentServiceImpl implements DepartmentService {
	
	@Autowired
	private DepartmentMapper mapper;

	@Override
	public List<TabHaobanDepartment> listByParentId(String parentId) {
		
		return mapper.listByParentId(parentId);
	}

	@Override
	public TabHaobanDepartment selectById(String departmentId) {
		
		return mapper.selectByPrimaryKey(departmentId);
	}

	@Override
	public String add(DepartmentDTO department) {
		Date now = new Date();
		TabHaobanDepartment tab = EntityUtil.changeEntityByJSON(TabHaobanDepartment.class, department);
		tab.setCreateTime(now);
		tab.setUpdateTime(now);
		tab.setStatusFlag(1);
		tab.setDepartmentId(StringUtil.randomUUID());
		mapper.insert(tab);
		return tab.getDepartmentId();
		
	}

	@Override
	public void edit(DepartmentDTO department) {
		Date now = new Date();
		TabHaobanDepartment tab = EntityUtil.changeEntityByJSON(TabHaobanDepartment.class, department);
		tab.setUpdateTime(now);
		mapper.updateByPrimaryKeySelective(tab);
		
	}

	@Override
	public void del(String departmentId) {
		mapper.deleteByPrimaryKey(departmentId);
		
	}

}
