package com.gic.haoban.manage.web.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.haoban.base.api.common.Constant;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
public class DepartmentContoller extends WebBaseController{
	@Autowired
	private DepartmentApiService departmentApiService;
	
	@RequestMapping("department-list")
	public HaobanResponse departmentList(String parentId) {
		List<DepartmentDTO> list = departmentApiService.listByParentId(parentId);
		
		return resultResponse(HaoBanErrCode.ERR_1,list);
		
	}
	
	@RequestMapping("department-add")
	public HaobanResponse departmentAdd(String parentId,String departmentName) {
		DepartmentDTO dto = departmentApiService.selectById(parentId);
		if(dto == null || dto.getStatusFlag() == 0) {
			return resultResponse(HaoBanErrCode.ERR_10001);
		}
		if(dto.getIsStore() == 1) {
			return resultResponse(HaoBanErrCode.ERR_10002);
		}
		DepartmentDTO department = new DepartmentDTO();
		department.setParentDepartmentId(parentId);
		department.setDepartmentName(departmentName);
		department.setChainId(dto.getChainId() + Constant.ID_SEPARATOR + dto.getDepartmentId());
		department.setIsStore(0);
		departmentApiService.add(department);
	
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}
	
	@RequestMapping("department-edit")
	public HaobanResponse departmentEdit(String departmentId,String departmentName) {
		DepartmentDTO dto = departmentApiService.selectById(departmentId);
		if(dto == null || dto.getStatusFlag() == 0) {
			return resultResponse(HaoBanErrCode.ERR_10001);
		}
		dto.setDepartmentName(dto.getDepartmentName());
		departmentApiService.edit(dto);
	
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}
	
	@RequestMapping("department-sel")
	public HaobanResponse departmentSel(String departmentId) {
		DepartmentDTO dto = departmentApiService.selectById(departmentId);
		if(dto == null || dto.getStatusFlag() == 0) {
			return resultResponse(HaoBanErrCode.ERR_10003);
		}
	
		return resultResponse(HaoBanErrCode.ERR_1,dto);
		
	}
	
	@RequestMapping("department-del")
	public HaobanResponse departmentDel(String departmentId) {
		DepartmentDTO dto = departmentApiService.selectById(departmentId);
		if(dto == null || dto.getStatusFlag() == 0) {
			return resultResponse(HaoBanErrCode.ERR_10003);
		}
	
		departmentApiService.del(departmentId);
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}


}
